## Copyright (C) 2004 Eric Chassande-Mottin
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

function tfr = dwv1(x)
% Computes discrete time/frequency Wigner as defined in : Peyrin and Prost, IEEE ASSP-34:4, pp 858-866, 1986

N=length(x);

tfr=zeros(N,2*N);
tfr(:,1)=x.*conj(x([1,N:-1:2]));
tfr(:,2)=x.*conj(x([2,1,N:-1:3]));
for icol=2:N-2,
  x1=x([icol:N,1:icol-1]);
  tfr(:,2*icol-1)=x1.*conj(x([icol:-1:1,N:-1:icol+1]));
  tfr(:,2*icol)  =x1.*conj(x([icol+1:-1:1,N:-1:icol+2]));
end;
x1=x([N-1:N,1:N-2]);
tfr(:,2*N-3)=x1.*conj(x([N-1:-1:1,N]));
tfr(:,2*N-2)  =x1.*conj(x(N:-1:1));
x1=x([N,1:N-1]);
tfr(:,2*N-1)=x1.*conj(x(N:-1:1));
tfr(:,2*N)  =x1.*conj(x([1,N:-1:2]));

tfr=fft(tfr);
tfr=[tfr;tfr];

c=exp(pi*i*(0:2*N-1)'/N);
tfr(:,2:2:2*N)=(c*ones(1,N)).*tfr(:,2:2:2*N);

tfr=real(tfr);
